
/***** define macros *****/

#define SPACE ' '
#define RETURN '\n'
#define SCREEN_SIZE 22

#define NO_MEM 0        /* return types for record linker */
#define NOT_UNQ 1
#define LINKED 2

#define DISPATCH_TABLE_SIZE 11

#define ERROR_TABLE_SIZE 16

#define HELP_TABLE_SIZE 13



/****** include headers ****/



/****** globals externs ****/

typedef int (*FP)();

enum bool {false,true};

extern char *cmd_line;                        /*  command line */

extern struct dispatch_table
{
 char *function_name;
 FP function_pointer;
} table[DISPATCH_TABLE_SIZE];

extern struct  error_table
{
 char *message;
 int fatal;
} etable[ERROR_TABLE_SIZE];

extern struct help_table
{
 char *name;
 char *descrip;
} htable[HELP_TABLE_SIZE];

extern struct stu
{
 char *name;
 long id;
 struct stu *prev;
 struct stu *next;
} *start;

/****** functions externs ***/

extern FP search();  /* function pointer table searching function */

extern int addemup();

extern int view();

extern int help();

extern int add_student();

extern int link_student();

extern int show_students();

extern int find();

extern struct stu *search_id();

extern struct stu *search_name();

extern int delete();

extern int delete_student();

extern void release_all();
